yags.CC <- function(x, y, id, tim, maxiter = 15, tol = 0.0001, family, corstr = "identity",
	alpin, betin = NULL, Ua.tol = 0.001, Ua.maxit = 20, verbose = F, 
	Ua.gridlo = 0.1, Ua.gridhi = 0.9, Ua.gridnpts = 10, Ua.secantdel = 0.01,
weights=rep(1,length(id)))
{
	#int* verbose, 
	#double* Uagrid_lo, double* Uagrid_hi, int* Uagrid_npts, 
	#double* Uasecant_del)
	if(is.matrix(y) && ncol(y) == 1) y <- as.double(y)
	if(is.null(betin)) betin <- glm(y ~ x - 1, family = family)$coef
	n <- length(y)
	p <- ncol(x)
	q <- length(alpin)
if (corstr == "unstructured")
         {
         q <- (max(tim)+1)^2  # strange
         }
	phi <- 1.
	b0 <- betin
	bout <- b0
	alpout <- rep(0,q)
	bcov.naive <- matrix(0, p, p)
	bcov.rob <- matrix(0, p, p)
	famtag <- family()$family[1]
	if(is.na(famcode <- match(famtag, c("Gaussian", "Binomial", "Poisson",
		"Gamma"))))
		stop("only gaussian, binomial, poisson, Gamma fams supported")
	if(is.na(corcode <- match(corstr, c("independence", "exchangeable", 
		"UJ.fom", "ar1", "UQ.fom","unstructured"))))
		stop("only independence, exchangeable, UJ.fom, ar1, UQ.fom, unstructured corstrs supported"
			)
	out <- .C("tcc2",
		as.integer(n),
		as.integer(p),
		as.integer(q),
		as.double(x),
		as.double(y),
		as.double(id),
		as.double(tim),
		as.double(b0),
		bout = as.double(bout),
		outiter = as.integer(maxiter),
		tol = as.double(tol),
		as.integer(famcode),
		as.integer(corcode),
		as.double(alpin),
		aout = as.double(alpout),
		phiout = as.double(phi),
		bcov.naive = as.double(bcov.naive),
		bcov.rob = as.double(bcov.rob),
		ua = as.double(0),
		duda = as.double(rep(0, q^2)),
		sum.uut = as.double(rep(0, q^2)),
		ua.tol = as.double(Ua.tol),
		uamaxit = as.integer(Ua.maxit),
		as.integer(verbose),
		as.double(Ua.gridlo),
		as.double(Ua.gridhi),
		as.integer(Ua.gridnpts),
		as.double(Ua.secantdel), as.double(weights))
	#print(out$aout)
	tmpsig <- list(coef = out$bout, alpest = out$aout, phiest = out$phiout,
		bcov.naive = out$bcov.naive, bcov.rob = out$bcov.rob, ua = out[[
		"ua"]], duda = out$duda, sum.uut = out$sum.uut, var.alp = out$
		sum.uut/out$duda^2)
	#print(tmpsig)
   if (corcode != 3) tmpsig$var.alp <- NA
	tmp.eta <- as.double(x %*% tmpsig$coef)
	tmp.mu <- family()$inverse(tmp.eta)
	mpp <- function(x, p)
	matrix(x, p, p)
	final.out <- list(coefficients = tmpsig$coef, naive.parmvar = mpp(
		tmpsig$bcov.naive, p), robust.parmvar = mpp(tmpsig$bcov.rob,
		p), alpha = tmpsig$alpest, phi = tmpsig$phiest, 
		linear.predictors = tmp.eta, fitted.values = as.double(tmp.mu),
		residuals = as.double(y - tmp.mu), iter = out$outiter, family
		 = family, rank = p, errorcode = NULL, sealp = sqrt(tmpsig$
		var.alp))
	# provisional error
        if (is.na(tmpsig$ua)) warning("U.alpha apparently unsolved, check working model adequacy")
	else if(abs(tmpsig$ua) > Ua.tol) warning(paste(
			"Alp est func not solved, results suspect, Ua=", round(
			tmpsig$ua, 5), sep = ""))
	#oldClass(final.out) <- "yags"
	final.out
}
